﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Allocation_of_Investments
{
    internal class Bank_Works
    {
        public int[,] Method_Investments_Into_data()
        {
            Console.WriteLine("Введите максимальную сумму: ");
            int max_price = Convert.ToInt32(Console.ReadLine());
            Console.WriteLine("Введите шаг разбиения суммы: ");
            int step_price = Convert.ToInt32(Console.ReadLine());
            Console.WriteLine("Введите количество Банков: ");
            int banks_count = Convert.ToInt32(Console.ReadLine());
            int[,] osnova_vkladov = new int[(max_price / step_price) + 2, banks_count + 1]; //Массив входных данных
            for (int i = 0; i < osnova_vkladov.GetLength(0); i++) //Ввод данных в массив, кол-во груза на складах и для потребителей
            {
                for (int j = 0; j < osnova_vkladov.GetLength(1); j++)
                {
                    if (i == 0 && j == 0)
                    {
                        osnova_vkladov[i, j] = 0; //В углу таблицы ничего не заполняется
                    }
                    if(i == 1)
                    {
                        osnova_vkladov[1, j] = 0;
                    }
                    else if (j == 0)
                    {
                        osnova_vkladov[i, 0] = i * step_price;
                    }
                    else if (i == 0)
                    {
                        osnova_vkladov[0, j] = j;
                    }
                }
            }
            for (int i = 2; i < osnova_vkladov.GetLength(0); i++) //Ввод отдельно тарифы
            {
                for (int j = 1; j < osnova_vkladov.GetLength(1); j++)
                {
                    Console.WriteLine("Введите проценты банков:");
                    osnova_vkladov[i, j] = int.Parse(Console.ReadLine());
                }
            }
            //int[,] osnova_vkladov = { { 0, 1, 2, 3, 4 }, { 0, 0, 0, 0, 0 }, { 50, 25, 26, 27, 28 }, { 100, 34, 33, 35, 55 }, { 150, 46, 46, 45, 44 }, { 200, 57, 58, 56, 55 } };
            for (int i = 0; i < osnova_vkladov.GetLength(0); i++) //Вывод данного массива для обзора

            {
                for (int j = 0; j < osnova_vkladov.GetLength(1); j++)
                {
                    Console.Write("[" + i + "," + j + "]: " + osnova_vkladov[i, j] + "\t");
                }
                Console.WriteLine();
            }
            Console.WriteLine();
            return osnova_vkladov;
        }
        public void Method_Investments(int[,] osnova_vkladov)
        {
            List<List<int>> list_banks = new List<List<int>>();
            for (int i = 1; i < osnova_vkladov.GetLength(0); i++)
            {
                list_banks.Add(new List<int>());
                for (int j = 0; j < osnova_vkladov.GetLength(1); j++)
                {
                    list_banks[i - 1].Add(osnova_vkladov[i, j]);
                }
            }
            for (int i = 0; i < osnova_vkladov.GetLength(0) - 1; i++)
            {
                for (int j = 0; j < osnova_vkladov.GetLength(1); j++)
                {
                    Console.Write("[" + i + "," + j + "]: " + list_banks[i][j] + "\t");

                }
                Console.WriteLine();
            }
            int vs_otvet = 0;
            while (list_banks[0].Count > 2)
            {
                List<int> list_znach1 = new List<int>();
                List<int> list_max_znach1 = new List<int>();
                List<List<int>> list_price1 = new List<List<int>>();
                if (list_banks[0].Count > 3)
                {
                    for (int i = 0; i < list_banks.Count; i++)
                    {
                        for (int j = list_banks[i].Count - 1; j < list_banks[i].Count; j++)
                        {
                            int count = ((list_banks[1][0] * (i + 1)) / list_banks[1][0]) - 1;
                            for (int i1 = 0; i1 < ((list_banks[1][0] * (i + 1)) / list_banks[1][0]); i1++)
                            {
                                if (i == 0 && i1 == 0 && j == list_banks[i].Count - 1) list_znach1.Add(list_banks[i1][j]);
                                else
                                {
                                    list_znach1.Add(list_banks[i1][j - 1] + list_banks[count][j]);
                                    count--;
                                }
                            }

                            if (i == 0 && j == list_banks[i].Count - 1)
                            {
                                list_max_znach1.Add(0);
                            }
                            else
                            {
                                list_max_znach1.Add(list_znach1.Skip(list_znach1.Count - ((list_banks[1][0] * (i + 1)) / list_banks[1][0])).Take(list_znach1.Count).Max());

                            }
                        }
                    }
                }
                else
                {
                    for (int i = list_banks.Count - 1; i < list_banks.Count; i++)
                    {
                        for (int j = list_banks[i].Count - 1; j < list_banks[i].Count; j++)
                        {
                            int count = ((list_banks[1][0] * (i + 1)) / list_banks[1][0]) - 1;
                            for (int i1 = 0; i1 < ((list_banks[1][0] * (i + 1)) / list_banks[1][0]); i1++)
                            {
                                if (i == 0 && i1 == 0 && j == list_banks[i].Count - 1) list_znach1.Add(list_banks[i1][j]);
                                else
                                {
                                    list_znach1.Add(list_banks[i1][j - 1] + list_banks[count][j]);
                                    count--;
                                }
                            }
                            list_max_znach1.Add(list_znach1.Skip(list_znach1.Count - ((list_banks[1][0] * (i + 1)) / list_banks[1][0])).Take(list_znach1.Count).Max());
                        }
                    }
                }
                Console.WriteLine("\nЗначение расчета процента: ");
                for (int i = 0; i < list_znach1.Count; i++)
                {
                    Console.Write(list_znach1[i] + " ");
                }
                Console.WriteLine();
                Console.WriteLine("Максимальные значения процента: ");
                for (int i = 0; i < list_max_znach1.Count; i++)
                {
                    Console.Write(list_max_znach1[i] + " ");
                }
                for (int i = 0; i < list_banks.Count; i++)
                {
                    for (int j = list_banks[i].Count - 1; j < list_banks[i].Count; j++)
                    {
                        list_banks[i].RemoveAt(j);
                    }
                }
                if (list_banks[0].Count > 2)
                {
                    for (int i = 0; i < list_banks.Count; i++)
                    {
                        for (int j = list_banks[i].Count - 1; j < list_banks[i].Count; j++)
                        {
                            list_banks[i][j] = list_max_znach1[i];
                        }
                    }
                    Console.WriteLine();
                    Console.WriteLine("Вывод:");
                    for (int i = 0; i < list_banks.Count; i++)
                    {
                        for (int j = 0; j < list_banks[i].Count; j++)
                        {
                            Console.Write("[" + i + "," + j + "]: " + list_banks[i][j] + "\t");
                        }
                        Console.WriteLine();
                    }
                    Console.WriteLine();
                }
                vs_otvet = list_max_znach1.Max();
            }
            Console.WriteLine("\n\nОтвет:" + vs_otvet);
        }

    }
}
